/*
    Bantumi
    Copyright 2005 - 2007 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Martin Storsj
    martin@martin.st
*/

#ifndef __WINBT_H
#define __WINBT_H

#include "socketconn.h"
#include <winsock2.h>
#include <ws2bth.h>
#include <BluetoothAPIs.h>

class BTConnection : public SocketConnection {
public:
	~BTConnection();

	static bool available();

	static BTConnection *startConnect(BTH_ADDR addr, unsigned int uuid, const char **errString);
	static BTConnection *startAccept(unsigned int uuid, const char *serviceName, const char **errString);
	int pollAccept(int msec, const char **errString);

private:
	BTConnection(SOCKTYPE s);

	WSAQUERYSET service;
	ULONG sdpVersion;
	BTH_SET_SERVICE* serviceInfo;
	BLOB serviceBlob;
	HANDLE recordHandle;
	bool advertising;

};

#endif
